From 052bbf6f80d75651da06e72f591c7cdeaf1c677f Mon Sep 17 00:00:00 2001
From: Mike Palmiotto <mike.palmiotto@crunchydata.com>
Date: Tue, 17 Mar 2020 18:39:12 +0000
Subject: [PATCH 10/11] Add WalSenderType to subprocess struct

---
 src/backend/postmaster/subprocess.c | 11 +++++++++++
 src/include/postmaster/subprocess.h |  1 +
 2 files changed, 12 insertions(+)

diff --git a/src/backend/postmaster/subprocess.c b/src/backend/postmaster/subprocess.c
index 9d7ce86918..8cc88792ea 100644
--- a/src/backend/postmaster/subprocess.c
+++ b/src/backend/postmaster/subprocess.c
@@ -181,6 +181,17 @@ static PgSubprocess process_types[] = {
 		.entrypoint = BackendMain,
 		.fork_failure = BackendForkFailure,
 		.postmaster_main = BackendPostmasterMain
+	},
+	{	/* Wal Sender placeholder */
+		.name = "walsender",
+		.desc = "wal sender",
+		.needs_aux_proc = false,
+		.needs_shmem = false,
+		.keep_postmaster_memcontext = false,
+		.fork_prep = NULL,
+		.entrypoint = NULL,
+		.fork_failure = NULL,
+		.postmaster_main = NULL
 	}
 };
 
diff --git a/src/include/postmaster/subprocess.h b/src/include/postmaster/subprocess.h
index 06e67efecc..867e1cb499 100644
--- a/src/include/postmaster/subprocess.h
+++ b/src/include/postmaster/subprocess.h
@@ -31,6 +31,7 @@ typedef enum
 	BgWorkerType,
 	ClientBackendType,
 
+	WalSenderType,				/* placeholder for wal sender so it can be identified in pgstat */
 	NUMSUBPROCESSTYPES			/* Must be last! */
 } SubprocessType;
 
-- 
2.21.1

